#pragma once

#include "Scriptlet.h"
class Binding;
class NPCOMMONUI_API CComponentScriptletPlugin : public IScriptletComponentPlugin
{
public:
	CComponentScriptletPlugin(void);
	virtual ~CComponentScriptletPlugin(void);

	//override
	CComponent* CreateComponent(CContainer* pParent, TiXmlElement* pNode);
	
	BOOL GenerateComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode);
protected:
	//override
	BOOL PreModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode);
	BOOL ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode);
	BOOL PostModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode);

	virtual CComponent* _CreateComponent(TiXmlElement* pNode) = 0;
	
private:
	CComponent* CreateComponentByName(TiXmlElement* pNode);
	CComponent* CreateRefineComponent(CContainer* pParent, TiXmlElement* pNode);
	void CheckBinding(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode);

	BOOL ParseBinding( CContainer* pParent, CComponent* pTarget, CString attrName, CString &attrValue );
};
